#include <QtGui>
#include <QLCDNumber>

#include "digitalclock.h"


DigitalClock::DigitalClock(QWidget *parent)
    : QWidget(parent)
{
    qDebug("DigitalClock(QWidget *parent)");
    resize(320, 240);
    move(0,0);
    setWindowFlags(Qt::CustomizeWindowHint|Qt::FramelessWindowHint);
    this->setStyleSheet("background-image:url(:/images/beijing.png);");
    lcdNumber=new QLCDNumber;
    lcdNumber->setSegmentStyle(QLCDNumber::Filled);
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(showTime()));
    setWindowTitle(tr("Digital Clock"));

    date=new QLabel(lcdNumber);
    date->setGeometry(2,2,294,30);
    date->setStyleSheet("color: rgb(255, 255, 255);font: 13pt;" );

    QGridLayout *mainlayout=new QGridLayout;

    mainlayout->addWidget(lcdNumber,0,0,7,1);
    this->setLayout(mainlayout);

}



void DigitalClock::showTime()

{
    qDebug("void DigitalClock::showTime()");
    QTime time = QTime::currentTime();
    QString text = time.toString("hh:mm");
    QDate dateC = QDate::currentDate();
    if(dateText!=(dateC.toString(tr("yyyy年MM月dd日"))))
    {
        dateText = dateC.toString(tr("yyyy年MM月dd日"));
        int week;
        week=dateC.dayOfWeek();
        switch (week)
        {
        case 1:
            {
                dateText+=tr("    星期一");
            }
            break;
        case 2:
            {
                dateText+=tr("    星期二");
            }
            break;
        case 3:
            {
                dateText+=tr("    星期三");
            }
            break;
        case 4:
            {
                dateText+=tr("    星期四");
            }
            break;
        case 5:
            {
                dateText+=tr("    星期五");
            }
            break;
        case 6:
            {
                dateText+=tr("    星期六");
            }
            break;
        case 7:
            {
                dateText+=tr("    星期天");
            }
            break;
        default:break;
        }
        QString dateCache=tr("      ");
        dateCache+=dateText;
        date->setText(dateCache);
    }
    if ((time.second() % 2) == 0)
        text[2] = ' ';
    lcdNumber->display(text);
}

void DigitalClock::mousePressEvent(QMouseEvent *)
{
    this->close();
    timer->stop();
    update();
}

void DigitalClock::keyPressEvent(QKeyEvent *event)
{
      if(event->key() == Qt::Key_Escape)
      {
          close();
          timer->stop();
      }
}
