#include <QtGui>
#include <QTimer>
#include <QDebug>

#include "mainmenu.h"
#include "window.h"
#include "digitalclock.h"
#include "set.h"


Mainmenu :: Mainmenu()
{
    this->move(0,0);
    resize(320, 240);
    setWindowFlags(Qt::CustomizeWindowHint|Qt::FramelessWindowHint);
    window = new Window;
    digitalclock = new DigitalClock;
    set=new Set;

    frame = new QFrame;
    photo = new QPushButton(frame);
    movie = new QPushButton(frame);
    music = new QPushButton(frame);
    ebook = new QPushButton(frame);
    clock = new QPushButton(frame);
    setBtn   = new QPushButton(frame);

    mainlayout1=new QGridLayout;

    frame->setObjectName("myframe");
    frame->resize(800,600);
    frame->setStyleSheet("QFrame#myframe{border-image:url(:/images/beijing.png)}" );
    photo->setGeometry(32,36,52,52);
    movie->setGeometry(125,36,52,52);
    music->setGeometry(218,36,52,52);
    ebook->setGeometry(32,133,52,52);
    clock->setGeometry(125,133,52,52);
    setBtn->setGeometry(218,133,52,52);

    photo->setStyleSheet("background-image: url(:/images/photo.png);");
    movie->setStyleSheet("background-image: url(:/images/movie.png);");
    music->setStyleSheet("background-image: url(:/images/music.png);");
    ebook->setStyleSheet("background-image: url(:/images/ebook.png);");
    clock->setStyleSheet("background-image: url(:/images/clock.png);");
    setBtn->setStyleSheet("background-image: url(:/images/set.png);");

    photo->setFlat(true);
    movie->setFlat(true);
    music->setFlat(true);
    ebook->setFlat(true);
    clock->setFlat(true);
    setBtn->setFlat(true);

    mainlayout1->addWidget(frame,0,0,6,6);
    setLayout(mainlayout1);
    setWindowTitle(tr("Digital photo frame"));
    connect(photo,SIGNAL(clicked()),this,SLOT(toPhoto()));
    connect(clock,SIGNAL(clicked()),this,SLOT(toClock()));
    connect(setBtn,SIGNAL(clicked()),this,SLOT(toSetup()));
}

//点击photo按钮后打开window的框架
void Mainmenu::toPhoto()
{
    qDebug("toPhoto()");
    window->show();
    window->timer_hide->start(5000);
    update();
}

void Mainmenu::toClock()
{
    qDebug("toClock()");
    digitalclock->show();
    digitalclock->timer->start(1000);
    digitalclock->showTime();
    update();
}

void Mainmenu::toSetup()
{
    set->show();
    update();
}

void Mainmenu::keyPressEvent(QKeyEvent *event)
{
      if(event->key() == Qt::Key_Escape)
      {
          close();
      }
}

