#include <QtGui>
#include <QDebug>
//#include <QFileDialog>

#include <stdlib.h>
#include <unistd.h>
#include "filedialog.h"



#include "renderarea.h"

RenderArea::RenderArea(QWidget *parent)
    : QWidget(parent)
{
    setAutoFillBackground(true);
    QPalette palette;
    palette.setBrush(backgroundRole(),QBrush(QColor(0,0,0),Qt::SolidPattern));
    setPalette(palette);
    timer_choose2_1= new QTimer( this );
    timer_choose2_2= new QTimer( this );
    timer_choose4_1=new QTimer(this);
    timer_choose4_2=new QTimer(this);
    connect( timer_choose2_1, SIGNAL(timeout()),this, SLOT(Reduce_choose()) );  //此信号槽用于choose=2时定时触发递减放大、旋转角度参数
    connect( timer_choose2_2, SIGNAL(timeout()),this, SLOT(Blow_choose()) );    //此信号槽用于choose=2时定时触发递增缩小、旋转角度参数
    connect( timer_choose4_1, SIGNAL(timeout()),this, SLOT(changeAlpha1()) );   //此信号槽用于choose=4时定时触发递减颜色透明度参数
    connect( timer_choose4_2, SIGNAL(timeout()),this, SLOT(changeAlpha2()) );   //此信号槽用于choose=4时定时触发递增颜色透明度参数
    connect(&m_animator5, SIGNAL(frameChanged(int)),this, SLOT(repaint()));            //此信号槽用于choose=5时timeline的帧数改变触发update
    connect(&m_animator6, SIGNAL(frameChanged(int)), SLOT(repaint()));            //此信号槽用于choose=6时timeline的帧数改变触发update
    connect(&m_animator7, SIGNAL(frameChanged(int)), SLOT(repaint()));            //此信号槽用于choose=7时timeline的帧数改变触发update
    timer_choose2_1->stop();
    timer_choose2_2->stop();
    timer_choose4_1->stop();
    timer_choose4_2->stop();
    m_animator5.stop();
    m_animator6.stop();
    m_animator7.stop();
    filedialog=new FileDialog;
    connect(filedialog,SIGNAL(newDir(QString)),this, SLOT(returnNewDir(QString)));
    choose=0;
    chooseCache=0;
    trans_nu=0;
    trans=0;
    dirNum=0;
    dirEndNum=0;
    w=1;
    h=1;
    flag2=false;
    flag5=false;
    flag6=false;
    flag7=false;
    openFlag=false;
    currentAlpha=0;
    i_dirpic=0;
    m_pixmap=QPixmap(":/images/beijing.png");
    update();
}

//初始化参数
bool RenderArea::init()
{
    qDebug("RenderArea::init");
    bool reTurn=false;
    dir=tr("/mnt/usb");
    dirlist<<dir;
    QDir picdir0(dir);
    if (!picdir0.exists()|| dir=="")
    {
        qDebug("x1");
        dirNum=-1;
        return reTurn;
    }
    picdir0.setFilter(QDir::Dirs|QDir::NoDotAndDotDot);
    QFileInfoList list0 = picdir0.entryInfoList();
    if(list0.size()<1)
    {
        QDir picdir_pic(dir);
        QStringList filters;
        filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
        picdir_pic.setNameFilters(filters);
        QFileInfoList list = picdir_pic.entryInfoList();
        if( (list.size()==0))
        {
        qDebug("x3");
        return reTurn;
        }
    }
    dirEndNum=list0.size();
    for(int ii=0;ii<list0.size();ii++)
    {
        QFileInfo fileInfo0 = list0.at(ii);
        QString  path=fileInfo0.filePath();
        dirlist<<path;
    }
    qDebug()<<dirlist.at(0);
    dirNum=picList(dirlist.at(dirNum));
    if(dirNum!=-1)
    {
        reTurn=true;
        emit getDir(dirlist.at(dirNum),0);
    }
    qDebug("dirNum=%d",dirNum);
    return reTurn;
}

//显示指定路径下第一张照片（遍历一层子目录）
int RenderArea::picList(QString nPicdir)
{
    QDir picdir(nPicdir);
    QStringList filters;
    filters << "*.bmp" << "*.jpg" << "*.png"<<"*.gif";
    picdir.setNameFilters(filters);
    QFileInfoList list = picdir.entryInfoList();
    if(list.size()<1 && dirNum<=dirEndNum)
    {
        qDebug("return");
        dirNum++;
        qDebug("dirEndNum0=%d",dirNum);
        if(dirNum==(dirEndNum+1))
        {
            qDebug("dirEndNum1=%d",dirNum);
            dirNum=-1;
            return dirNum;
        }
        qDebug("xxx");
        picList(dirlist.at(dirNum));
        qDebug("xxx");
        return dirNum;
    }
    QFileInfo fileInfo = list.at(0);
    QString  path=fileInfo.filePath();
    //init_put(path);
    pixlist[0]=QPixmap(path);
    m_lastPixmap = m_pixmap;
    double pixwidth1 = static_cast<double>(m_lastPixmap.width());
    double pixheight1 = static_cast<double>(m_lastPixmap.height());
    double showwidth1 = static_cast<double>(width());
    double showheight1 = static_cast<double>(height());
    double Wscalerate1 = pixwidth1 / showwidth1;
    double Hscalerate1 = pixheight1 / showheight1;
    double compare1 = (Wscalerate1 < Hscalerate1 ? Wscalerate1 : Hscalerate1);
    m_lastPixmap=m_lastPixmap.scaled(pixwidth1/compare1,pixheight1/compare1, Qt::IgnoreAspectRatio, Qt::FastTransformation);
    h=1;
    w=1;
    m_pixmap=pixlist[0];
    double pixwidth = static_cast<double>(m_pixmap.width());
    double pixheight = static_cast<double>(m_pixmap.height());
    qDebug("%f--%f",pixwidth,pixheight);
    double showwidth = static_cast<double>(width());
    double showheight = static_cast<double>(height());
    double Wscalerate = pixwidth / showwidth;
    double Hscalerate = pixheight / showheight;
    double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
    m_pixmap=m_pixmap.scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
    qDebug("init");
    update();
    return dirNum;
}

//画图事件-根据choose的值进入相应分支画图
void RenderArea::paintEvent(QPaintEvent *)
{
    qDebug("RenderArea::paintEvent");
    switch(choose)
    {
          case 0:       //切换效果0：无
        {
            double pixwidth = static_cast<double>(m_pixmap.width());
            double pixheight = static_cast<double>(m_pixmap.height());
            double showwidth = static_cast<double>(width());
            double showheight = static_cast<double>(height());
            double Wscalerate = pixwidth / showwidth;
            double Hscalerate = pixheight / showheight;
            double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);  //计算自动适应容器大小的比例值
            QRect rect1(
                showwidth/2.0 - pixwidth/compare/2.0,
                showheight/2.0- pixheight/compare/2.0,
                pixwidth/compare,
                pixheight/compare);
            QPainter painter(this);
            painter.fillRect(rect(), Qt::black);
            if(trans!=0)
            {
                painter.translate(size().width()/2, size().height()/2);
                painter.rotate(90*trans);
                painter.translate(-size().width()/2, -size().height()/2);
            }
            painter.save();
            painter.translate(showwidth/2.0, (showheight/2.0));
            painter.scale(w, h);
            painter.translate(-(showwidth/2), -(showheight/2.0));
            painter.drawPixmap(rect1, m_pixmap);
            painter.restore();
        }
          break;

          case 1:       //效果切换2：缩放
        {
              double pixwidth = static_cast<double>(m_pixmap.width());
              double pixheight = static_cast<double>(m_pixmap.height());
              double showwidth = static_cast<double>(width());
              double showheight = static_cast<double>(height());

              double Wscalerate = pixwidth / showwidth;
              double Hscalerate = pixheight / showheight;
              double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
              QRect rect1(
                    showwidth/2.0 - pixwidth/compare/2.0,
                    showheight/2.0- pixheight/compare/2.0,
                    pixwidth/compare,
                    pixheight/compare);
              QPainter painter(this);
            //  painter.fillRect(rect(), Qt::black);
              if(trans_nu!=0)
              {
                  painter.translate(size().width()/2, size().height()/2);
                  painter.rotate(trans_nu);
                  painter.translate(-size().width()/2, -size().height()/2);
              }
              painter.save();
              painter.translate(showwidth/2.0, (showheight/2.0));
              painter.scale(w, h);
              painter.translate(-(showwidth/2), -(showheight/2.0));
              painter.drawPixmap(rect1, m_pixmap);
              painter.restore();

        }
          break;

          case 2:       //效果切换4：淡入淡出
        {
              double pixwidth = static_cast<double>(m_pixmap.width());
              double pixheight = static_cast<double>(m_pixmap.height());
              double showwidth = static_cast<double>(width());
              double showheight = static_cast<double>(height());

              double Wscalerate = pixwidth / showwidth;
              double Hscalerate = pixheight / showheight;
              double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
              QRect rect1(
                    showwidth/2.0 - pixwidth/compare/2.0,
                    showheight/2.0- pixheight/compare/2.0,
                    pixwidth/compare,
                    pixheight/compare);
              QPainter painter(this);
             // painter.fillRect(rect(), Qt::black);
              painter.drawPixmap(rect1, m_pixmap);
              QColor semiTransparentColor =startColor;
              semiTransparentColor.setAlpha(currentAlpha);
              painter.fillRect(rect1,semiTransparentColor);
        }
          break;

          case 3:       //效果切换5：竖直滑动
       {
              m_animator5.setPaused(true);
              double index = m_animator5.currentFrame();
              double angle = index/1000.0;
              double pixwidth = static_cast<double>(m_pixmap.width());
              double pixheight = static_cast<double>(m_pixmap.height());
              double showwidth = static_cast<double>(width());
              double showheight = static_cast<double>(height());
              double Wscalerate = pixwidth / showwidth;
              double Hscalerate = pixheight / showheight;
              double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
              double pixwidth1 = static_cast<double>(m_lastPixmap.width());
              double pixheight1 = static_cast<double>(m_lastPixmap.height());
              double showwidth1 = static_cast<double>(width());
              double showheight1 = static_cast<double>(height());
              double Wscalerate1 = pixwidth1 / showwidth1;
              double Hscalerate1 = pixheight1 / showheight1;
              double compare1 = (Wscalerate1 <  Hscalerate1 ? Wscalerate1 : Hscalerate1);
              QPainter painter(this);
           //   painter.fillRect(rect(), Qt::black);
              if(flag5==false)
              {
                  QRect rect0(
                      showwidth/2.0-pixwidth/compare/2.0,
                      (showheight/2.0- pixheight/compare/2.0)-(showheight/2.0- pixheight/compare/2.0+pixheight/compare)*(1-angle),
                      pixwidth/compare,
                      pixheight/compare);
                  QRect rect1(
                      showwidth1/2.0 - pixwidth1/compare1/2.0,
                      showheight1/2.0- pixheight1/compare1/2.0+(showheight1/2.0-pixheight1/compare1/2.0+pixheight1/compare1)*(angle),
                      pixwidth1/compare1,
                      pixheight1/compare1);
                  painter.drawPixmap(rect1, m_lastPixmap);
                  painter.drawPixmap(rect0, m_pixmap);
              }
              else
              {
                  QRect rect0(
                      showwidth/2.0-pixwidth/compare/2.0,
                      (showheight/2.0- pixheight/compare/2.0)+(showheight/2.0- pixheight/compare/2.0+pixheight/compare)*(1-angle),
                      pixwidth/compare,
                      pixheight/compare);
                  QRect rect1(
                      showwidth1/2.0 - pixwidth1/compare1/2.0,
                      showheight1/2.0- pixheight1/compare1/2.0-(showheight1/2.0-pixheight1/compare1/2.0+pixheight1/compare1)*(angle),
                      pixwidth1/compare1,
                      pixheight1/compare1);
                  painter.drawPixmap(rect1, m_lastPixmap);
                  painter.drawPixmap(rect0, m_pixmap);
              }
              m_animator5.setPaused(false);

        }
          break;

          case 4:       //效果切换6：水平滑动
        {
              m_animator6.setPaused(true);
              double index = m_animator6.currentFrame();
              double angle = index/1000.0;
              double pixwidth = static_cast<double>(m_pixmap.width());
              double pixheight = static_cast<double>(m_pixmap.height());
              double showwidth = static_cast<double>(width());
              double showheight = static_cast<double>(height());
              double Wscalerate = pixwidth / showwidth;
              double Hscalerate = pixheight / showheight;
              double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
              double pixwidth1 = static_cast<double>(m_lastPixmap.width());
              double pixheight1 = static_cast<double>(m_lastPixmap.height());
              double showwidth1 = static_cast<double>(width());
              double showheight1 = static_cast<double>(height());
              double Wscalerate1 = pixwidth1 / showwidth1;
              double Hscalerate1 = pixheight1 / showheight1;
              double compare1 = (Wscalerate1 < Hscalerate1 ? Wscalerate1 : Hscalerate1);
              QPainter painter(this);
          //    painter.fillRect(rect(), Qt::black);
              if(flag6==false)
              {
                  QRect rect0(
                      showwidth/2.0-pixwidth/compare/2.0-(showwidth/2.0-pixwidth/compare/2.0+pixwidth/compare)*(1-angle),
                      (showheight/2.0- pixheight/compare/2.0),
                      pixwidth/compare,
                      pixheight/compare);
                  QRect rect1(
                      showwidth1/2.0 - pixwidth1/compare1/2.0+(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1)*(angle),
                      showheight1/2.0- pixheight1/compare1/2.0,
                      pixwidth1/compare1,
                      pixheight1/compare1);
                  painter.drawPixmap(rect1, m_lastPixmap);
                  painter.drawPixmap(rect0, m_pixmap);
              }
              else
              {
                  QRect rect0(
                      showwidth/2.0-pixwidth/compare/2.0+(showwidth/2.0-pixwidth/compare/2.0+pixwidth/compare)*(1-angle),
                      (showheight/2.0- pixheight/compare/2.0),
                      pixwidth/compare,
                      pixheight/compare);
                  QRect rect1(
                      showwidth1/2.0 - pixwidth1/compare1/2.0-(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1)*(angle),
                      showheight1/2.0- pixheight1/compare1/2.0,
                      pixwidth1/compare1,
                      pixheight1/compare1);
                  painter.drawPixmap(rect1, m_lastPixmap);
                  painter.drawPixmap(rect0, m_pixmap);
              }
              m_animator6.setPaused(false);
        }
          break;

          case 5:       //效果切换7：卷书翻页
        {
              m_animator7.setPaused(true);
              double pixwidth = static_cast<double>(m_pixmap.width());
              double pixheight = static_cast<double>(m_pixmap.height());
              double showwidth = static_cast<double>(width());
              double showheight = static_cast<double>(height());
              double Wscalerate = pixwidth / showwidth;
              double Hscalerate = pixheight / showheight;
              double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
              QRect rect0(
                  showwidth/2.0 - pixwidth/compare/2.0,
                  showheight/2.0- pixheight/compare/2.0,
                  pixwidth/compare,
                  pixheight/compare);
              double pixwidth1 = static_cast<double>(m_lastPixmap.width());
              double pixheight1 = static_cast<double>(m_lastPixmap.height());
              double showwidth1 = static_cast<double>(width());
              double showheight1 = static_cast<double>(height());
              double Wscalerate1 = pixwidth1 / showwidth1;
              double Hscalerate1 = pixheight1 / showheight1;
              double compare1 = (Wscalerate1 < Hscalerate1 ? Wscalerate1 : Hscalerate1);
              QRect rect1(
                  showwidth1/2.0 - pixwidth1/compare1/2.0,
                  showheight1/2.0- pixheight1/compare1/2.0,
                  pixwidth1/compare1,
                  pixheight1/compare1);
              QPainter painter(this);
         //     painter.fillRect(rect(), Qt::black);
              painter.setRenderHint(QPainter::SmoothPixmapTransform, true);
              painter.setRenderHint(QPainter::Antialiasing, true);
              double index = m_animator7.currentFrame();
              if(index>=1000)
              {
                  painter.drawPixmap(rect0,m_pixmap);
                  return;
              }
              if(flag7==false)
              {
                  QPoint mouse_pos=QPoint(((pixwidth1/compare1)*(1-index/1000)+(showwidth1/2.0 - pixwidth1/compare1/2.0)),((pixheight1/compare1)*(1-index/1000)+(showheight1/2.0- pixheight1/compare1/2.0)));
                  QPainterPath path1;
                  QPainterPath path2;
                  QPainterPath path3;
                  /* Draw region 1 */
                  painter.save ();
                  path1.moveTo(showwidth1/2.0 - pixwidth1/compare1/2.0,showheight1/2.0- pixheight1/compare1/2.0);
                  path1.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1,showheight1/2.0- pixheight1/compare1/2.0);
                  path1.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1,mouse_pos.y());
                  path1.lineTo(mouse_pos.x(),showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path1.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0,showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path1.closeSubpath();
                  painter.setClipPath (path1);
                  painter.drawPixmap (rect1,m_lastPixmap);
                  painter.restore();

                  /*Draw region 2*/
                  painter.save();
                  path2.moveTo(mouse_pos.x(), showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path2.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1,mouse_pos.y());
                  path2.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1, showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path2.closeSubpath ();
                  painter.setClipPath (path2);
                  painter.drawPixmap (rect0,m_pixmap);
                  painter.restore();

                  /* Draw region 3 */
                  path3.moveTo(mouse_pos.x(),(showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1));
                  path3.cubicTo(mouse_pos.x(),(showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1), mouse_pos.x()+9*index/50,(mouse_pos.y()+(showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1))/2, mouse_pos.x(), mouse_pos.y());
                  path3.cubicTo(mouse_pos.x(), mouse_pos.y(), (mouse_pos.x()+(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1))/2, mouse_pos.y()+7*index/50,showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1, mouse_pos.y());
                  path3.closeSubpath();
                  painter.setBrush(QBrush(QColor(0xF0,0xF8,0xFF)));
                  painter.setOpacity(0.7);
                  painter.drawPath(path3);
              }
              else if(flag7==true)
              {
                  QPoint mouse_pos=QPoint(((pixwidth1/compare1)*index/1000+(showwidth1/2.0 - pixwidth1/compare1/2.0)),((pixheight1/compare1)*(1-index/1000)+(showheight1/2.0- pixheight1/compare1/2.0)));

                  QPainterPath path1;
                  QPainterPath path2;
                  QPainterPath path3;

                  /* Draw region 1 */
                  painter.save ();
                  path1.moveTo(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1,showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path1.lineTo(mouse_pos.x(),showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path1.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0, mouse_pos.y());
                  path1.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0,showheight1/2.0- pixheight1/compare1/2.0);
                  path1.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0+pixwidth1/compare1,showheight1/2.0- pixheight1/compare1/2.0);
                  path1.closeSubpath();
                  painter.setClipPath (path1);
                  painter.drawPixmap (rect1, m_lastPixmap);
                  painter.restore();

                  /*Draw region 2*/
                  painter.save();
                  path2.moveTo(mouse_pos.x(),showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path2.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0, mouse_pos.y());
                  path2.lineTo(showwidth1/2.0 - pixwidth1/compare1/2.0, showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path2.closeSubpath ();
                  painter.setClipPath (path2);
                  painter.drawPixmap (rect0,m_pixmap);
                  painter.restore();

                  /* Draw region 3 */
                  path3.moveTo(mouse_pos.x(),showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1);
                  path3.cubicTo(mouse_pos.x(),showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1, mouse_pos.x()-9*index/50,(mouse_pos.y()+(showheight1/2.0- pixheight1/compare1/2.0+pixheight1/compare1))/2, mouse_pos.x(), mouse_pos.y());
                  path3.cubicTo(mouse_pos.x(), mouse_pos.y(), (mouse_pos.x())/2, mouse_pos.y()+7*index/50,showwidth1/2.0 - pixwidth1/compare1/2.0, mouse_pos.y());
                  path3.closeSubpath();
                  painter.setBrush(QBrush(QColor(0xF0,0xF8,0xFF)));
                  painter.setOpacity(0.7);
                  painter.drawPath(path3);
              }
              m_animator7.setPaused(false);
        }
          break;
          default:
          break;
    }
}

//切换下一张图片并根据choose开启切换效果
void RenderArea::fun_area()
{
    qDebug("RenderArea::fun_area()");
    QString usbdir=tr("/mnt/usb");
    QDir picdir(usbdir);
    picdir.setFilter(QDir::Files|QDir::Dirs|QDir::NoDotAndDotDot);
    QFileInfoList list0 = picdir.entryInfoList();
    if (list0.size()==0)
    {
        qDebug("usb--empty");
        return ;
    }
    auto_init();

    choose=chooseCache;
    if(choose==6)
    {
        choose=rand()%6;
    }
    m_lastPixmap = m_pixmap;
    init_case();
    dirNum=fun_dirList(dirlist.at(dirNum));
    emit getDir(dirlist.at(dirNum),i_dirpic);
    double pixwidth = static_cast<double>(pixlist[1].width());
    double pixheight = static_cast<double>(pixlist[1].height());
    double showwidth = static_cast<double>(width());
    double showheight = static_cast<double>(height());
    double Wscalerate = pixwidth / showwidth;
    double Hscalerate = pixheight / showheight;
    double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
    pixlist[1]=pixlist[1].scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
    m_pixmap=pixlist[1];
    switch (choose)
    {
    case 1:
        {
            h=1;
            w=1;
            trans_nu=0;
            flag2=false;
            timer_Choose2_1();
        }
        break;
    case 2:
        {
            timer_choose4_1->stop();
            timer_choose4_2->stop();
            timer_choose4_1->start(1);
        }
        break;
    case 3:
        {
            flag5=false;
            m_animator5.stop();
            m_animator5.start();
        }
        break;
    case 4:
        {
            flag6=false;
            m_animator6.stop();
            m_animator6.start();
        }
        break;
    case 5:
        {
            flag7=false;
            m_animator7.stop();
            m_animator7.start();
        }
        break;
    default:break;
    }
    if(choose!=1 && choose!=2 && choose!=4)
    {
        h=1;
        w=1;
        update();
    }
}

//点击下一张按钮时的切换图片
int RenderArea::fun_dirList(QString nPicdir)
{
    QDir picdir(nPicdir);
    QStringList filters;
    filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
    picdir.setNameFilters(filters);
    QFileInfoList list = picdir.entryInfoList();
    if( (list.size()==0))
    {
        dirNum++;
        if(dirNum==(dirEndNum+1))
        {
            dirNum=0;
        }
        i_dirpic=-1;
        fun_dirList(dirlist.at(dirNum));
        return dirNum;
    }
    if( i_dirpic<list.size()-1 )
    {
       i_dirpic++;
    }
    else if(i_dirpic==(list.size()-1))
    {
        dirNum++;
        if(dirNum==(dirEndNum+1))
        {
            dirNum=0;
        }
        i_dirpic=-1;
        fun_dirList(dirlist.at(dirNum));
        return dirNum;
    }
    QFileInfo fileInfo = list.at(i_dirpic);
    QString  path=fileInfo.filePath();
    pixlist[1]=QPixmap(path);
    return dirNum;
}

//切换前一张图片并根据choose开启切换效果
void RenderArea::pre_area()
{
    qDebug("RenderArea::pre_area()");
    QString usbdir=tr("/mnt/usb");
    QDir picdir(usbdir);
    picdir.setFilter(QDir::Files|QDir::Dirs|QDir::NoDotAndDotDot);
    QFileInfoList list0 = picdir.entryInfoList();
    if (list0.size()==0)
    {
        qDebug("usb--empty");
        return ;
    }
    auto_init();
    choose=chooseCache;
    if(choose==6)
    {
        choose=rand()%6;
    }
    m_lastPixmap = m_pixmap;
    init_case();
    dirNum=pre_dirList(dirlist.at(dirNum));
    emit getDir(dirlist.at(dirNum),i_dirpic);
    double pixwidth = static_cast<double>(pixlist[1].width());
    double pixheight = static_cast<double>(pixlist[1].height());
    double showwidth = static_cast<double>(width());
    double showheight = static_cast<double>(height());
    double Wscalerate = pixwidth / showwidth;
    double Hscalerate = pixheight / showheight;
    double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
    pixlist[1]=pixlist[1].scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
    m_pixmap=pixlist[1];
    switch (choose)
    {
    case 1:
        {
            h=1;
            w=1;
            trans_nu=0;
            flag2=true;
            timer_Choose2_1();
        }
        break;
    case 2:
        {
            timer_choose4_1->stop();
            timer_choose4_2->stop();
            timer_choose4_1->start(1);
        }
        break;
    case 3:
        {
            flag5=true;
            m_animator5.stop();
            m_animator5.start();
        }
        break;
    case 4:
        {
            flag6=true;
            m_animator6.stop();
            m_animator6.start();
        }
        break;
    case 5:
        {
            flag7=true;
            m_animator7.stop();
            m_animator7.start();
        }
        break;
    default:break;
    }
    if(choose!=2 && choose!=4)
    {
        h=1;
        w=1;
        update();
    }
}

//点击上一张按钮时的切换图片
int RenderArea::pre_dirList(QString nPicdir)
{
    QDir picdir(nPicdir);
    QStringList filters;
    filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
    picdir.setNameFilters(filters);
    QFileInfoList list = picdir.entryInfoList();
    if( (list.size()==0))
    {
        dirNum--;
        if(dirNum<0)
        {
            dirNum=dirEndNum;
        }
        QDir picdir(dirlist.at(dirNum));
        QStringList filters;
        filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
        picdir.setNameFilters(filters);
        QFileInfoList list = picdir.entryInfoList();
        i_dirpic=list.size();
        pre_dirList(dirlist.at(dirNum));
        return dirNum;
    }
    if(i_dirpic>0 && i_dirpic<=list.size())
    {
       i_dirpic--;
    }
    else if(i_dirpic<=0)
    {
        dirNum--;
        if(dirNum<0)
        {
            dirNum=dirEndNum;
        }
        QDir picdir(dirlist.at(dirNum));
        QStringList filters;
        filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
        picdir.setNameFilters(filters);
        QFileInfoList list = picdir.entryInfoList();
        i_dirpic=list.size();
        pre_dirList(dirlist.at(dirNum));
        return dirNum;
    }
    QFileInfo fileInfo = list.at(i_dirpic);
    QString  path=fileInfo.filePath();
    pixlist[1]=QPixmap(path);
    return dirNum;
}

//设置放大参数
void RenderArea::Blow()
{
    choose=0;
    if(w==1)
    {

        QDir picdir(dirlist.at(dirNum));
        QStringList filters;
        filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
        picdir.setNameFilters(filters);
        QFileInfoList list = picdir.entryInfoList();
        QFileInfo fileInfo = list.at(i_dirpic);
        QString  path=fileInfo.filePath();
        m_pixmap=QPixmap(path);
    }
    if(w<4)
    {
        w=w*1.05;
        h=h*1.05;
        update();
    }
}

//设置缩小参数
void RenderArea::Reduce()
{
    choose=0;
    if(w==1)
    {

        QDir picdir(dirlist.at(dirNum));
        QStringList filters;
        filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
        picdir.setNameFilters(filters);
        QFileInfoList list = picdir.entryInfoList();
        QFileInfo fileInfo = list.at(i_dirpic);
        QString  path=fileInfo.filePath();
        m_pixmap=QPixmap(path);
    }
    if(w>0.1)
    {
        w=w*0.95;
        h=h*0.95;
        update();
    }
}

//选择新图片所在文件夹路径并显示第一张图片
void RenderArea::open()
{
    qDebug("RenderArea::open()");
    auto_init();
    bool reTurn=false;
    if(openFlag==false)
    {
        filedialog->show();
        openFlag=true;
    }
    else
    {
        openFlag=false;
        QStringList dirlist1;
        QString dir1;
        int dirNum1;
        int dirEndNum1;
        int i_dirpic1;          //用于缓存前一文件夹信息
        dirNum1=dirNum;
        dirEndNum1=dirEndNum;
        i_dirpic1=i_dirpic;
        dirlist1<<dirlist;
        dir1=dir;
        dir=dir_cache;
        QDir picdir0(dir);
        if (!picdir0.exists()|| dir=="")
        {
            return;
        }
        picdir0.setFilter(QDir::Dirs|QDir::NoDotAndDotDot);
        QFileInfoList list0 = picdir0.entryInfoList();
        if(list0.size()<1)
        {
            QDir picdir_pic(dir);
            QStringList filters;
            filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
            picdir_pic.setNameFilters(filters);
            QFileInfoList list = picdir_pic.entryInfoList();
            if( (list.size()==0))
            {
            return;
            }
        }
        dirlist.clear();
        dirlist<<dir;
        dirNum=0;
        dirEndNum=list0.size();
        for(int ii=0;ii<list0.size();ii++)
        {
            QFileInfo fileInfo0 = list0.at(ii);
            QString  path=fileInfo0.filePath();
            dirlist<<path;
        }
        dirNum=picList(dirlist.at(dirNum));
        if(dirNum!=-1)
        {
            reTurn=true;
            emit getDir(dirlist.at(dirNum),0);
        }
        if(dirNum==-1)
        {
            dirNum=dirNum1;
            dirEndNum=dirEndNum1;
            i_dirpic=i_dirpic1;
            dirlist.clear();
            dirlist<<dirlist1;
            dir=dir1;
        }
    }
    emit returnFlag(reTurn);
    return ;
}


//设置旋转角度90°的倍数
void RenderArea::transformbutton()
{
    choose=0;
    trans++;
    update();
}


void RenderArea::resizeEvent(QResizeEvent*)
{
    qDebug("RenderArea::resizeEvent(QResizeEvent*)");
}


//choose切换效果的一些设置及动作
void  RenderArea::init_case()
{
    qDebug("RenderArea::init_case()");
    switch(choose)
    {
    case 3:
    {
    setAttribute(Qt::WA_OpaquePaintEvent, true);
    setAttribute(Qt::WA_NoSystemBackground, true);
    m_animator5.stop();
    m_animator5.setFrameRange(0,1000);
    m_animator5.setDuration(20000);//1500
    m_animator5.setCurveShape(QTimeLine::EaseInOutCurve);
    }
    break;

    case 4:
    {
    setAttribute(Qt::WA_OpaquePaintEvent, true);
    setAttribute(Qt::WA_NoSystemBackground, true);
    m_animator6.stop();
    m_animator6.setFrameRange(0,1000);
    m_animator6.setDuration(20000);
    m_animator6.setCurveShape(QTimeLine::EaseInOutCurve);
    }
    break;

    case 5:
    {
    setAttribute(Qt::WA_OpaquePaintEvent, true);
    setAttribute(Qt::WA_NoSystemBackground, true);
    m_animator7.stop();
    m_animator7.setFrameRange(0, 1000);
    m_animator7.setDuration(20000);
    m_animator7.setCurveShape(QTimeLine::EaseInOutCurve);
    }
    break;
    default: break;
    }
}

//同步相应切换效果对应的值并初始化
void  RenderArea::changestytle(int newchoose)
{
    qDebug("RenderArea::changestytle(int newchoose)");
    chooseCache=newchoose;
    choose=0;
    auto_init();
    m_lastPixmap=m_pixmap;
    update();
}

void  RenderArea::auto_init()
{
    timer_choose2_1->stop();
    timer_choose2_2->stop();
    m_animator5.stop();
    m_animator6.stop();
    m_animator7.stop();
    timer_choose4_1->stop();
    timer_choose4_2->stop();
    h=1;
    w=1;
    trans_nu=0;
    trans=0;
    currentAlpha=0;
    flag2=false;
    flag7=false;
}

//choose=2时设置放大及旋转角度参数
void RenderArea::Blow_choose()
{
    qDebug("RenderArea::Blow_choose()");
    if(flag2==false)
    {
        if(w<0.95)
        {
            w=w/0.85;
            h=h/0.85;
            trans_nu-=25;
            this->repaint();
        }
        else
        {
            timer_choose2_2->stop();
            w=1;
            h=1;
            this->repaint();
        }
    }
    else
    {
        if(w<0.95)
        {
            w=w/0.85;
            h=h/0.85;
            trans_nu+=25;
            this->repaint();
        }
        else
        {
            timer_choose2_2->stop();
            w=1;
            h=1;
            this->repaint();
        }
    }

    return ;
}

//choose=2时设置缩小及旋转角度参数
void RenderArea::Reduce_choose()
{
    qDebug("RenderArea::Reduce_choose()");
    if(flag2==false)
    {
        if(w>0.05)
        {
            w=w*0.85;
            h=h*0.85;
            trans_nu+=25;
            this->repaint();
        }
        else
        {
            timer_choose2_1->stop();
            timer_Choose2_2();
            return;
        }
    }
    else
    {
        if(w>0.05)
        {
            w=w*0.85;
            h=h*0.85;
            trans_nu-=25;
            this->repaint();
        }
        else
        {
            timer_choose2_1->stop();
            timer_Choose2_2();
            return;

        }
    }

    return ;
}

//choose=2时开启定时器1
void RenderArea::timer_Choose2_1()
{
    timer_choose2_1->stop();
    timer_choose2_2->stop();
    m_pixmap=m_lastPixmap;
    double pixwidth = static_cast<double>(m_pixmap.width());
    double pixheight = static_cast<double>(m_pixmap.height());
    double showwidth = static_cast<double>(width());
    double showheight = static_cast<double>(height());
    double Wscalerate = pixwidth / showwidth;
    double Hscalerate = pixheight / showheight;
    double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
    m_pixmap=m_pixmap.scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
    timer_choose2_1->start(10);
    return;
}

//choose=2时开启定时器2，两个定时器结合用于实现缩放旋转效果
void RenderArea::timer_Choose2_2()
{
    timer_choose2_2->stop();
    timer_choose2_1->stop();
    m_pixmap=pixlist[1];
    double pixwidth = static_cast<double>(m_pixmap.width());
    double pixheight = static_cast<double>(m_pixmap.height());
    double showwidth = static_cast<double>(width());
    double showheight = static_cast<double>(height());
    double Wscalerate = pixwidth / showwidth;
    double Hscalerate = pixheight / showheight;
    double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
    m_pixmap=m_pixmap.scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
    timer_choose2_2->start(10);
    return;
}

//choose=4时改变透明度参数
void RenderArea::changeAlpha1()
{
    qDebug("RenderArea::changeAlpha1()");
    if(currentAlpha<15)
    {
        m_pixmap=m_lastPixmap;
        double pixwidth = static_cast<double>(m_pixmap.width());
        double pixheight = static_cast<double>(m_pixmap.height());
        double showwidth = static_cast<double>(width());
        double showheight = static_cast<double>(height());
        double Wscalerate = pixwidth / showwidth;
        double Hscalerate = pixheight / showheight;
        double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
        m_pixmap=m_pixmap.scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
        currentAlpha+=15;
    }
    else if(currentAlpha<245)
    {
        currentAlpha+=15;
    }
    else
    {
        timer_choose4_1->stop();
        timer_choose4_2->stop();
        timer_choose4_2->start(1);
        currentAlpha=255;
        return;
    }
    this->repaint();
    return;
}

//choose=4时改变透明度参数-两段函数结合使用timeline实现淡入淡出效果
void RenderArea::changeAlpha2()
{
    qDebug("RenderArea::changeAlpha2()");
    if(currentAlpha>240)
    {
        m_pixmap=pixlist[1];
        double pixwidth = static_cast<double>(m_pixmap.width());
        double pixheight = static_cast<double>(m_pixmap.height());
        double showwidth = static_cast<double>(width());
        double showheight = static_cast<double>(height());
        double Wscalerate = pixwidth / showwidth;
        double Hscalerate = pixheight / showheight;
        double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
        m_pixmap=m_pixmap.scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
        currentAlpha-=15;
    }
    if(currentAlpha>1)
    {
        currentAlpha-=15;
    }
    else
    {
        currentAlpha=0;
        timer_choose4_1->stop();
        timer_choose4_2->stop();
        return;
    }
    this->repaint();
    return;
}

//槽函数用于同步showList的图片序号并同步显示
void RenderArea::getShowList(int i_S)
{
    qDebug("RenderArea::getShowList(int i_S)");
    i_dirpic=i_S;
    QDir picdir(dirlist.at(dirNum));
    QStringList filters;
    filters << "*.jpg" << "*.bmp" << "*.png"<<"*.gif";
    picdir.setNameFilters(filters);
    QFileInfoList list = picdir.entryInfoList();
    QFileInfo fileInfo = list.at(i_dirpic);
    QString  path=fileInfo.filePath();
    m_pixmap=QPixmap(path);
    double pixwidth = static_cast<double>(m_pixmap.width());
    double pixheight = static_cast<double>(m_pixmap.height());
    double showwidth = static_cast<double>(width());
    double showheight = static_cast<double>(height());
    double Wscalerate = pixwidth / showwidth;
    double Hscalerate = pixheight / showheight;
    double compare = (Wscalerate < Hscalerate ? Wscalerate : Hscalerate);
    m_pixmap=m_pixmap.scaled(pixwidth/compare,pixheight/compare, Qt::IgnoreAspectRatio, Qt::FastTransformation);
    update();
}


void RenderArea::returnNewDir(QString newdir)
{
    qDebug("returnNewDir(QString newdir)");
    dir_cache=newdir;
    this->open();

}
