#ifndef RENDERAREA_H
#define RENDERAREA_H

#include <QBrush>
#include <QPen>
#include <QPixmap>
#include <QWidget>
#include <QFileDialog>
#include <QTimeLine>
#include <QPainter>
#include <QColor>

#include "filedialog.h"

class RenderArea : public QWidget
{
    Q_OBJECT

public:
    RenderArea(QWidget *parent = 0);
    //QSize minimumSizeHint() const;
   // QSize sizeHint() const;
    FileDialog *filedialog;
    bool init();                //初始化参数以及显示指定路径下第一张照片
    void auto_init();           //初始化定时器及参数
    void fun_area();            //切换前一张图片并根据choose开启切换效果
    void pre_area();            //切换前一张图片并根据choose开启切换效果
    void Blow();                //设置放大参数
    void Reduce();              //设置缩小参数
    void open();                //选择新图片所在文件夹路径并显示第一张图片
    void transformbutton();     //设置旋转角度90°的倍数
    void init_case();          //choose切换效果的一些设置及动作
    void timer_Choose2_1();     //choose=2时开启定时器1
    void timer_Choose2_2();     //choose=2时开启定时器2
    int  picList(QString picdir);//显示指定路径下第一张照片（遍历一层子目录）
    int  fun_dirList(QString nPicdir);//点击下一张按钮时的切换图片
    int  pre_dirList(QString nPicdir);//点击上一张按钮时的切换图片


    int i_dirpic;          //图片序号
    int choose;     //切换方式序号
    int chooseCache;//切换方式序号暂放用于区分放大缩小旋转功能；
    bool flag2;
    bool flag5;
    bool flag6;
    bool flag7;     //choose不同切换方式时fun/pre_area区分图片效果
    int dirNum;     //指定当前目录在指定目录下一层子目录的序号
    int dirEndNum;  //指定指定目录下一层子目录的数量
    bool openFlag;

signals:
    void getDir(QString,int);       //信号用于同步图片文件夹路径以及图片序号
    void returnFlag(bool);

public slots:
    void changestytle(int newchoose);
    void Blow_choose();             //choose=2时设置放大及旋转角度参数
    void Reduce_choose();           //choose=2时设置缩小及旋转角度参数
    void changeAlpha1();            //choose=4时改变透明度参数
    void changeAlpha2();            //choose=4时改变透明度参数-两段函数结合使用timeline实现淡入淡出效果
    void getShowList(int);          //槽函数用于同步showList的图片序号并同步显示
    void returnNewDir(QString);


protected:
    void paintEvent(QPaintEvent *);
   // void mousePressEvent(QMouseEvent *);
    void resizeEvent(QResizeEvent *);

private:
    QString dir;                    //存放图片所在文件夹路径
    QTimeLine m_animator5;           //choose=5时使用的timeline
    QTimeLine m_animator6;           //choose=6时使用的timeline
    QTimeLine m_animator7;           //choose=7时使用的timeline
    QPixmap m_pixmap;               //后一张需显示的图片
    QPixmap m_lastPixmap;           //前一张需显示的图片
    QPixmap pixlist[2];             //临时存放前后两张需显示的图片
    QTimer *timer_choose2_1;        //choose=2时的定时器timer1
    QTimer *timer_choose2_2;        //choose=2时的定时器timer2
    QTimer *timer_choose4_1;        //choose=4时的定时器timer1
    QTimer *timer_choose4_2;        //choose=4时的定时器timer1
    QColor startColor;              //choose=4时用于设置颜色透明度的color类
    int trans;      //旋转角度90°的倍数
    float w;        //宽度的放大缩小参数
    float h;        //高度的放大缩小参数
    int trans_nu;   //choose=2时的旋转角度参数
    int currentAlpha;//定义color类的颜色透明度

    QStringList dirlist; //指定目录包含一层子目录的路径列表
    QString dir_cache;
};


#endif
