#include <QtGui>
#include <QPushButton>

#include "set.h"
#include "setdatetime.h"

Set::Set(QWidget *parent)
    : QWidget(parent)
{
    this->move(0,0);
    resize(320, 240);
    setWindowFlags(Qt::CustomizeWindowHint|Qt::FramelessWindowHint);
    setAutoFillBackground(true);
    QPixmap pixmap(":/images/beijing.jpg");
    QPalette palette;
    palette.setBrush(backgroundRole(), QBrush(pixmap));
    setPalette(palette);

    setdatetime = new SetDateTime;
    DateTime = new QPushButton(tr("时间设置"));
    Brightness = new QPushButton(tr("亮度调节"));
    About = new QPushButton(tr("关于我们"));
    Back = new QPushButton(tr("返回"));

    DateTime->setFixedSize(150, 40);
    Brightness->setFixedSize(150, 40);
    About->setFixedSize(150, 40);
    Back->setFixedSize(150, 40);

    DateTime->setStyleSheet("background-image: url(:/images/1.jpg);font: 16pt;color: rgb(255, 255, 0);");
    Brightness->setStyleSheet("background-image: url(:/images/2.jpg);font: 16pt;color: rgb(155, 100, 255);");
    About->setStyleSheet("background-image: url(:/images/3.jpg);font: 16pt;color: rgb(0, 255, 255);");
    Back->setStyleSheet("background-image: url(:/images/1.jpg);font: 16pt;color: rgb(255, 255, 100 );");

    belowlayout_set = new QVBoxLayout;
    belowlayout_set->addWidget(DateTime);
    belowlayout_set->addWidget(Brightness);
    belowlayout_set->addWidget(About);
    belowlayout_set->addWidget(Back);
    mainlayout_set = new QGridLayout;
    mainlayout_set->addLayout(belowlayout_set,0,0,0,0,Qt::AlignHCenter);
    setLayout(mainlayout_set);
    setWindowTitle(tr("Set"));

    connect(Back,SIGNAL(clicked()),this,SLOT(SettoMainmenu()));
    connect(DateTime,SIGNAL(clicked()),this,SLOT(tosetdatetime()));
}


QSize Set::minimumSizeHint() const
{
    return QSize(320,240);
}
QSize Set::sizeHint() const
{
    return QSize(320,240);
}

void Set::SettoMainmenu()
{
    this->close();
}
void Set::tosetdatetime()
{
    setdatetime->show();
    update();
}

