#include "setdatetime.h"
#include "set.h"
#include <stdio.h>
#include <stdlib.h>
#include <QDateTimeEdit>
#include <QProcess>
#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/rtc.h>
#include <sys/ioctl.h>
#include <unistd.h>
SetDateTime::SetDateTime(QWidget *parent)
    : QWidget(parent)
{
    this->move(0,0);
    resize(320, 240);
    setWindowFlags(Qt::CustomizeWindowHint|Qt::FramelessWindowHint);
    setAutoFillBackground(true);
    QPixmap pixmap(":/images/beijing.jpg");
    QPalette palette;
    palette.setBrush(backgroundRole(), QBrush(pixmap));
    setPalette(palette);

    Save = new QPushButton(tr("确定"));
    Back = new QPushButton(tr("返回"));
    Save->setFixedSize(50, 30);
    Back->setFixedSize(50, 30);
    Save->setStyleSheet("background-image: url(:/images/1.jpg);font: 12pt;color: rgb(255, 255, 0);");
    Back->setStyleSheet("background-image: url(:/images/2.jpg);font: 12pt;color: rgb(255, 255, 0);");

    label1 = new QLabel("DATE");
    label2 = new QLabel("TIME");
    label1->setFixedSize(50,40);
    label2->setFixedSize(50,40);
    label1->setStyleSheet("font: 15pt;color: rgb(255, 255, 0);");
    label2->setStyleSheet("font: 15pt;color: rgb(255, 255, 0);");


    dateEdit = new QDateTimeEdit(QDateTime::currentDateTime());
    dateEdit->setDisplayFormat("yyyy.MM.dd");
    dateEdit->setMaximumSize(200,70);
    dateEdit->setMinimumSize(200,70);
    QFont font = QFont("hel24",24,50);
    dateEdit->setFont(font);


    timeEdit = new QDateTimeEdit(QDateTime::currentDateTime());
    timeEdit->setDisplayFormat("hh:mm:ss");
    timeEdit->setMaximumSize(200,70);
    timeEdit->setMinimumSize(200,70);
    QFont font1 = QFont("hel24",24,50);
    timeEdit->setFont(font1);



    belowlayout_setdatetime1 = new QHBoxLayout;
    belowlayout_setdatetime2 = new QHBoxLayout;
    belowlayout_setdatetime3 = new QHBoxLayout;
    mainlayout_setdatetime = new QGridLayout;

    belowlayout_setdatetime1->addWidget(label1);
    belowlayout_setdatetime1->addWidget(dateEdit);
    belowlayout_setdatetime2->addWidget(label2);
    belowlayout_setdatetime2->addWidget(timeEdit);
    belowlayout_setdatetime3->addWidget(Save);
    belowlayout_setdatetime3->addWidget(Back);


    mainlayout_setdatetime->addLayout(belowlayout_setdatetime1,0,0,1,1,Qt::AlignHCenter);
    mainlayout_setdatetime->addLayout(belowlayout_setdatetime2,1,0,1,1,Qt::AlignHCenter);
    mainlayout_setdatetime->addLayout(belowlayout_setdatetime3,2,0,1,1,Qt::AlignHCenter);
    this->setLayout(mainlayout_setdatetime);

    connect(dateEdit, SIGNAL(dateTimeChanged (QDateTime)), this, SLOT(date(QDateTime)));
    connect(timeEdit, SIGNAL(dateTimeChanged (QDateTime)), this, SLOT(date(QDateTime)));
    connect(Back,SIGNAL(clicked()),this,SLOT(SetDateTimetoSet()));
    connect(Save,SIGNAL(clicked()),this,SLOT(setRealTime()));


}

QSize SetDateTime::minimumSizeHint() const
{
    return QSize(320,240);
}
QSize SetDateTime::sizeHint() const
{
    return QSize(320,240);
}

void SetDateTime::SetDateTimetoSet()
{
    this->hide();
}

bool SetDateTime::setRealTime()
{
  int fd, retval;
  struct tm rtc_tm;
  QDateTime EndDate,StartDate,logEndDate,logStartDate,nouploadDate;
  QStringList templist;
  QStringList templist2;
  time_t t;
  struct tm nowtime;
  int year,month,day,hour,min,sec;
  qDebug()<<"set time is "<<temp;
  templist = temp.split(" ");
  if(templist.count() < 2) return false;
  temp = templist.at(0);
  templist2 = temp.split("-");
  if(templist2.count()<3) return false;
  year = templist2.at(0).toInt();
  month = templist2.at(1).toInt();
  day = templist2.at(2).toInt();
  temp = templist.at(1);
  templist2 = temp.split(":");
  if(templist2.count() < 3) return false;
  hour = templist2.at(0).toInt();
  min = templist2.at(1).toInt();
  sec = templist2.at(2).toInt();
  qDebug("hour=%d",hour);
  qDebug()<<year<<" "<<month<<" "<<day<<" "<<hour<<" "<<min<<" "<<sec;
  if(year<2000 || year > 2099 || month <1 || month >12 || day <1 || day >31 || hour < 0 || hour > 23 || min < 0 || min > 59 || sec <0 || sec > 60)
  {
  return false;
  }

  nowtime.tm_sec=sec;// Seconds.[0-60] (1 leap second)
  nowtime.tm_min=min;// Minutes.[0-59]
  nowtime.tm_hour=hour;// Hours. [0-23]
  nowtime.tm_mday=day;// Day.[1-31]
  nowtime.tm_mon=month-1;// Month. [0-11]
  nowtime.tm_year=year-1900 ;// Year- 1900.
  nowtime.tm_isdst=-1 ;//DST.[-1/0/1]
  t=mktime(&nowtime);
  stime(&t);
  qDebug()<<"set time success";

  EndDate = EndDate.currentDateTime();
  StartDate = EndDate.addMSecs(100);
  logEndDate = logEndDate.currentDateTime();
  logStartDate = logEndDate.addDays(1);
  nouploadDate = nouploadDate.currentDateTime();

  fd = open ("/dev/rtc0", O_RDONLY);
  if (fd == -1)
  {
      ::close(fd);
  //qDebug()<<"hw rtc open fail!";
  }
  rtc_tm.tm_year = year-1900;
  rtc_tm.tm_mon = month-1;
  rtc_tm.tm_mday = day;
  rtc_tm.tm_hour = hour;
  rtc_tm.tm_min = min;
  rtc_tm.tm_sec = sec;
  retval = ioctl(fd, RTC_SET_TIME, &rtc_tm);
  if (retval == -1)
  {
  ::close(fd);
  qDebug()<<"hw rtc set fail!";
  return false;
  }
  ::close(fd);
  return true;
}

void SetDateTime::date(const QDateTime & dateTime)
{

    temp=dateTime.toString("yyyy-MM-dd hh:mm:ss");
    qDebug()<<temp;

}
