#include <QtGui>
#include <QDebug>
#include <QFileInfo>
#include <QListWidgetItem>

#include "showlist.h"

ShowList::ShowList(QWidget *parent)
    : QWidget(parent)
{
    setAutoFillBackground(true);
    QPixmap pixmap(":/images/beijing.png");
    QPalette palette;
    palette.setBrush(backgroundRole(), QBrush(pixmap));
    setPalette(palette);

    frame = new QFrame;
    frame->resize(320,240);
    frame->setWindowFlags(Qt::CustomizeWindowHint|Qt::FramelessWindowHint);


    flag1=false;
    list1 = new QListWidget(frame);
    list1->setGeometry(35,155,214,55);
    label0=new QLabel(frame);
    label0->setGeometry(10,5,260,145);
    list1->setViewMode(QListView::IconMode);
    list1->setMovement(QListView::Static);
    list1->setResizeMode(QListView::Fixed);
    list1->setFocusPolicy(Qt::NoFocus);

    item0 = new QListWidgetItem;
    item1 = new QListWidgetItem;
    item2 = new QListWidgetItem;
    item3 = new QListWidgetItem;
    item4 = new QListWidgetItem;
    pp[0]=item0;
    pp[1]=item1;
    pp[2]=item2;
    pp[3]=item3;
    pp[4]=item4;
    for(int it=0;it<5;it++)
    {
        list1->insertItem((it+1),pp[it]);
    }
    leftbutton=new QPushButton(frame);
    rightbutton=new QPushButton(frame);
    leftbutton->setStyleSheet("background-image: url(:/images/left.png);");
    rightbutton->setStyleSheet("background-image: url(:/images/right.png);");
    leftbutton->setFlat(true);
    rightbutton->setFlat(true);
    leftbutton->setGeometry(0,160,35,35);
    rightbutton->setGeometry(250,160,35,35);

    reButton=new QPushButton(tr("R"),frame);
    reButton->setGeometry(218,156,30,50);
    reButton->setStyleSheet("background-image: url(:/images/reT.png);");
    reButton->setFlat(true);

    mainlayout=new QGridLayout;
    mainlayout->addWidget(frame,0,0,5,5);
    setLayout(mainlayout);

    connect(leftbutton,SIGNAL(clicked()),this,SLOT(left()));
    connect(rightbutton,SIGNAL(clicked()),this,SLOT(right()));
    connect(list1,SIGNAL(itemClicked(QListWidgetItem*)),this,SLOT(showR(QListWidgetItem*)));
    connect(reButton,SIGNAL(clicked()),this,SLOT(retWin()));
}

QSize ShowList::minimumSizeHint() const
{
    return QSize(300,220);
}
QSize ShowList::sizeHint() const
{
    return QSize(300,220);
}

//自动调整控件大小
void ShowList::resizeEvent(QResizeEvent*)
{
    list1->setMinimumSize(214,55);
    list1->setMaximumSize(214,55);
    list1->setIconSize(QSize(38,36));
    for(int it=0;it<5;it++)
    {
        pp[it]->setSizeHint(QSize(36,50));
    }
    leftbutton->setMinimumSize(35,35);
    leftbutton->setMaximumSize(35,35);
    rightbutton->setMinimumSize(35,35);
    rightbutton->setMaximumSize(35,35);
}

//设置背景色为白色
void ShowList::paintEvent(QPaintEvent *)
{
    qDebug("ShowList::paintEvent(QPaintEvent *)");
}

//同步当前文件夹路径以及图片序号信息的槽函数
void ShowList::pathList(QString newpath,int num)
{
    qDebug("ShowList::pathList(QString newpath,int num)");
    qDebug("back");
    pathBack=newpath;
    i=num;
    i_cache=num;
}


//根据图片文件夹以及图片序号更新图片列表以及图片显示
void ShowList::picList()
{
    qDebug("ShowList::picList()");
    flag1=true;
    QDir picdir(pathBack);
    QStringList filters;
    filters << "*.bmp" << "*.jpg" << "*.png"<<"*.gif";
    picdir.setNameFilters(filters);
    QFileInfoList list = picdir.entryInfoList();
    QFileInfo fileInfo;
    QString  path;
    fileInfo = list.at(i);
    path=fileInfo.filePath();
    QImage image;
    image.load(path);
    QPixmap sealPixmap = QPixmap::fromImage( image.scaled(320,195,Qt::KeepAspectRatio) );
    //sealPixmap=sealPixmap.scaled(320,195,Qt::IgnoreAspectRatio, Qt::FastTransformation);
    label0->setPixmap(sealPixmap);
    this->repaint();
    int ii=i;
    int i1=i-1;
    for(int it=0;it<5;it++)
    {
        pp[it]->setHidden(false);
    }
    if(list.size()<6)
    {
        ii=0;
        for(int it=list.size();it<5;it++)
        {
            pp[it]->setHidden(true);
        }
        for(int it=0;it<list.size()&& it<5;it++)
        {
                fileInfo = list.at(ii);
                path=fileInfo.filePath();
                QImage image;
                image.load(path);
                sealPixmap1 = QPixmap::fromImage( image.scaled(38,36,Qt::KeepAspectRatio) );
                pp[it]->setIcon(sealPixmap1);
                path.replace(pathBack, QString(""));
                path=path.remove(QChar('/'),Qt::CaseInsensitive);
                pp[it]->setText(path);
                ii++;
        }
    }
    else if(list.size()>=6)
    {
        for(int it=2;it<5;it++)
            {
                if( ( (ii>0) || (ii==0) ) && ( (ii<list.size()) ))
                {
                    fileInfo = list.at(ii);
                    path=fileInfo.filePath();
                    QImage image;
                    image.load(path);
                    sealPixmap1 = QPixmap::fromImage( image.scaled(38,36,Qt::KeepAspectRatio) );
                    pp[it]->setIcon(sealPixmap1);
                    path.replace(pathBack, QString(""));
                    path=path.remove(QChar('/'),Qt::CaseInsensitive);
                    pp[it]->setText(path);
                    ii++;
                }
                if(ii==(list.size()))
                {
                    ii=0;
                }
            }
        for(int it=1;it>=0;it--)
        {
            if(i1==-1)
            {
                i1=list.size()-1;
            }
            if( (i1>=0))
            {
                fileInfo = list.at(i1);
                path=fileInfo.filePath();
                QImage image;
                image.load(path);
                sealPixmap1 = QPixmap::fromImage( image.scaled(38,36,Qt::KeepAspectRatio) );
                pp[it]->setIcon(sealPixmap1);
                path.replace(pathBack, QString(""));
                path=path.remove(QChar('/'),Qt::CaseInsensitive);
                pp[it]->setText(path);
                i1--;
            }
        }
    }
    update();
}

//点击leftbutton触发的槽函数用于更新列表以及显示上一张图片
void ShowList::left()
{
    flag1=true;
    QDir picdir(pathBack);
    QStringList filters;
    filters << "*.bmp" << "*.jpg" << "*.png"<<"*.gif";
    picdir.setNameFilters(filters);
    QFileInfoList list = picdir.entryInfoList();
    if(list.size()<=0)
    {
        return;
    }
    if(i==0)
    {
        i=list.size()-1;
    }
    else
        i=i-1;
    picList();
}

//点击rightbutton触发的槽函数用于更新列表以及显示下一张图片
void ShowList::right()
{
    flag1=true;
    QDir picdir(pathBack);
    QStringList filters;
    filters << "*.bmp" << "*.jpg" << "*.png"<<"*.gif";
    picdir.setNameFilters(filters);
    QFileInfoList list = picdir.entryInfoList();
    if(list.size()<=0)
    {
        return;
    }
    if(i==(list.size()-1))
    {
        i=0;
    }
    else
        i=i+1;
    picList();
}

//item被单击后触发的槽函数用于实现点击切换
void ShowList::showR(QListWidgetItem* item)
{
    qDebug("ShowList::showR(QListWidgetItem* item)");
    if(flag1==true)
    {
        for(int it=0;it<5;it++)
        {
            switch(item==pp[it])
            {
            case 1:
                {
                   change_i=it;
                   break;
                }
            default:break;
            }
        }
        QDir picdir(pathBack);
        QStringList filters;
        filters << "*.bmp" << "*.jpg" << "*.png"<<"*.gif";
        picdir.setNameFilters(filters);
        QFileInfoList list = picdir.entryInfoList();
        if(list.size()<=0)
        {
            return;
        }
        int i_showR=i;
        if(list.size()<6)
        {
            i_showR=change_i;
        }
        else
        {
            i_showR=i_showR+(change_i-2);
        }
        if(i_showR<0)
        {
            i=list.size()+i_showR;
        }
        else if(i_showR>=list.size())
        {
            i=i_showR-list.size();
        }
        else
            i=i_showR;
       // timer_s->start(10);
    }
    picList();
}


void ShowList::retWin()
{
    qDebug("ShowList::retWin()");
    emit ListDir(i);
}
