#ifndef SHOWLIST_H
#define SHOWLIST_H

#include <QWidget>
#include <QGridLayout>
#include <QLineEdit>
#include <QListWidget>
#include <QListWidgetItem>
#include <QPushButton>
#include <QLabel>
#include <QPixmap>
#include <QTimer>

class ShowList : public QWidget
{
    Q_OBJECT

public:

    ShowList(QWidget *parent = 0);
    QSize minimumSizeHint() const;
    QSize sizeHint() const;

    QPushButton *leftbutton;
    QPushButton *rightbutton;
  //  QTimer *timer_s;              //用于区分鼠标单击与双击事件的定时器

    void picList();             //初始化图片列表以及图片显示
    int i;                      //图片序号
    int i_cache;                //图片序号
    int change_i;               //点击切换时的序号偏移量


signals:
    void ListDir(int);          //切换会renderArea界面的同时同步图片序号信息

public slots:
    void pathList(QString,int);     //同步当前文件夹路径以及图片序号信息的槽函数
    void left();                    //点击leftbutton触发的槽函数用于更新列表以及显示下一张图片
    void right();                   //点击rightbutton触发的槽函数用于更新列表以及显示下一张图片
    void showR(QListWidgetItem*);   //item被单击后触发的槽函数用于实现点击切换
  //  void showRen(QListWidgetItem*); //item被双击后触发的槽函数用于实现切换回renderArea界面
 //   void mouseClick();              //定时触发鼠标单击item后的动作用于区分单击双击事件
    void retWin();


protected:
    void paintEvent(QPaintEvent *event);
   // void mousePressEvent(QMouseEvent *);
    void resizeEvent(QResizeEvent *);

private:
    QString pathBack;            //图片文件夹路径
    QGridLayout *mainlayout;     //布局
    QListWidget *list1;          //图片列表显示控件
    QListWidgetItem *item0;
    QListWidgetItem *item1;
    QListWidgetItem *item2;
    QListWidgetItem *item3;
    QListWidgetItem *item4;      //用于存放图片列表的五个item
    QListWidgetItem *pp[5];      //用于映射五个存放图片列表item的指针
    QPixmap sealPixmap;          //用于存放当前图片大图缓存
    QPixmap sealPixmap1;         //用于存放图片缩略图缓存
    QLabel *label0;              //用于显示当前图片大图的容器
    bool flag1;                  //区分单击双击事件的标志
    QFrame *frame;
    QPushButton *reButton;
};


#endif
