#ifndef WINDOW_H
#define WINDOW_H
#include <QPixmap>
#include <QWidget>
#include <QComboBox>
#include <QGridLayout>
#include <QHBoxLayout>
#include <QPushButton>
#include <QFrame>

class RenderArea;
class ShowList;

class Window : public QWidget
{
    Q_OBJECT
public:
    Window();
    //QSize minimumSizeHint() const;
    //QSize sizeHint() const;
    RenderArea *renderArea;
    ShowList *showList;
    QFrame *chooseN;
    QPushButton *frontbutton;
    QPushButton *nextbutton;
    QPushButton *blowupbutton;
    QPushButton *reducebutton;
    QPushButton *findbutton;
    QPushButton *transformbutton;
    QPushButton *exitbutton;
    QPushButton *autobutton;
    QPushButton *backbutton;
    QPushButton *comboBox;
    QTimer *timer;       //自动播放使用的定时器
    QTimer *timer_hide;  //按键自动隐藏使用的定时器
    QGridLayout *mainlayout;
    QHBoxLayout *belowlayout;
    QHBoxLayout *belowlayout1;
    QPushButton *choose0;
    QPushButton *choose1;
    QPushButton *choose2;
    QPushButton *choose3;
    QPushButton *choose4;
    QPushButton *choose5;
    QPushButton *choose6;

    bool reTurn;
    bool reTurn1;

signals:
    void chooseNum(int);

public slots:
    void backList();     //槽函数用于切换到showList界面
    void backRen(int);   //槽函数用于切换到renderArea界面
    void buttonFlag(bool);

private:

protected:
    void keyPressEvent(QKeyEvent *event);
    void mousePressEvent(QMouseEvent *);

private slots:
    void predisplay();          //按键触发前一张图片切换槽函数
    void nextdisplay();         //按键触发后一张图片槽函数
    void blow();                //按键触发放大槽函数
    void reduce();              //按键触发缩小槽函数
    void find();                //按键触发更改图片所在文件夹路径槽函数
    void autoplay();            //按键触发自动播放功能开启定时器槽函数
    void transform_btn();       //按键触发图片旋转功能槽函数
    void btn_hide();            //此定时器槽函数实现按键定时自动隐藏
    void changestytle(int);     //此槽函数实现选择图片切换效果之后隐藏三个图片处理键
    void play();                //此槽函数在定时之后自动切换下一张图片
    void ToReturn();
    void chooseS();
    void choose00();
    void choose11();
    void choose22();
    void choose33();
    void choose44();
    void choose55();
    void choose66();
};

#endif // WINDOW_H
